unit CFNamer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,DSGNINTF, CNamer, RkTabLst, Spin;

type
  TFCompon = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    RkTabL: TRkTabbedListBox;
    NameVal: TEdit;
    Label1: TLabel;
    MaxValueIndex: TSpinEdit;
    Label2: TLabel;
    btnChange: TSpeedButton;
    CancelChangeBtn: TSpeedButton;
    procedure btnChangeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelChangeBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    TOldValues : TStringList;
  end;

  TComponentPropertyEditor = class(TPropertyEditor)
  public
    { Public declarations }
    Function GetAttributes:TPropertyAttributes; Override;
    Function GetValue : String; Override;
    Procedure Edit; Override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

{$R *.DFM}

Function TComponentPropertyEditor.GetValue : String;
Begin
  Result := Format('%S', [GetPropType^.Name]);
End;

Function TComponentPropertyEditor.GetAttributes:TPropertyAttributes;
Begin
  Result := [PaDialog, PaReadOnly];
End;

Procedure TComponentPropertyEditor.Edit;
Var
  I           : Integer;
  ComponenterN: TComponentNamer;
  CompView    : TFCompon;
Begin
  CompView := TFCompon.Create(Application);
  Try
    ComponenterN := GetComponent(0) As TComponentNamer;
    CompView.RkTabL.Items.Assign(ComponenterN.Componenter);
    CompView.TOldValues.Assign(ComponenterN.Componenter);
    If CompView.ShowModal = MrOk Then Begin
      For I := 0 To CompView.TOldValues.Count-1 Do Begin
        If Pos(#9,CompView.TOldValues[I]) <> 0 Then Begin
          ComponenterN.Owner.FindComponent(Trim(CompView.TOldValues[I])).Name :=
            Trim(CompView.RkTabL.Items[I]);
        End;
      End;
      Designer.Modified;
    End;
  Finally
    CompView.TOldValues.Free;
    CompView.Free;
  End;
End;

procedure Register;
Begin
  RegisterPropertyEditor(TypeInfo(TStringList),TComponentNamer,'Componenter',
                         TComponentPropertyEditor);
End;

Procedure TFCompon.btnChangeClick(Sender: TObject);
Var
  I,T,Y      : Integer;
Begin
  T := 0;
  //Find the first selected Item.
  Y := MaxValueIndex.Value;
  While (Not (RkTabL.Selected[T])) AND (T < RkTabl.Items.Count) Do Begin
    Inc(T);
  End;
  If RkTabL.Selected[T] Then Begin
    If Pos(#9,RkTabL.Items[T])<>0 Then Begin
      For I := T To RkTabl.Items.Count-1 Do
      Begin
        If RkTabl.Selected[I] Then Begin
          RkTabl.Items[I] :=#9+NameVal.Text+IntToStr(Y);
          Inc(Y);
        End
      End;
    End
    Else Begin
      Inc(T);
      If T < RkTabl.Items.Count-1 Then begin
        While (T < RkTabl.Items.Count) AND (Pos(#9,RkTabL.Items[T])<>0) Do Begin
          RkTabl.Items[T] :=#9+NameVal.Text+IntToStr(Y);
          Inc(Y);
          Inc(T);
        End;
      End;
    End;
  End;
End;

procedure TFCompon.FormCreate(Sender: TObject);
begin
  TOldValues  := TStringList.Create;
end;

procedure TFCompon.CancelChangeBtnClick(Sender: TObject);
begin
  RkTabl.Clear;
  RkTabl.Items.Assign(TOldValues);
end;

end.
